/*
* React Tooltip
* {@link https://github.com/ReactTooltip/react-tooltip}
* @copyright ReactTooltip Team
* @license MIT
*/
import e,{createContext as t,useState as r,useCallback as o,useMemo as n,useContext as l,useRef as i,useEffect as c,useLayoutEffect as s}from"react";import{arrow as a,computePosition as d,offset as u,flip as p,shift as v,autoUpdate as m}from"@floating-ui/dom";import y from"classnames";const f="react-tooltip-core-styles",h="react-tooltip-base-styles",w={core:!1,base:!1};function b({css:e,id:t=h,type:r="base",ref:o}){var n,l;if(!e||"undefined"==typeof document||w[r])return;if("core"===r&&"undefined"!=typeof process&&(null===(n=null===process||void 0===process?void 0:process.env)||void 0===n?void 0:n.REACT_TOOLTIP_DISABLE_CORE_STYLES))return;if("base"!==r&&"undefined"!=typeof process&&(null===(l=null===process||void 0===process?void 0:process.env)||void 0===l?void 0:l.REACT_TOOLTIP_DISABLE_BASE_STYLES))return;"core"===r&&(t=f),o||(o={});const{insertAt:i}=o;if(document.getElementById(t))return void console.warn(`[react-tooltip] Element with id '${t}' already exists. Call \`removeStyle()\` first`);const c=document.head||document.getElementsByTagName("head")[0],s=document.createElement("style");s.id=t,s.type="text/css","top"===i&&c.firstChild?c.insertBefore(s,c.firstChild):c.appendChild(s),s.styleSheet?s.styleSheet.cssText=e:s.appendChild(document.createTextNode(e)),w[r]=!0}function S({type:e="base",id:t=h}={}){if(!w[e])return;"core"===e&&(t=f);const r=document.getElementById(t);"style"===(null==r?void 0:r.tagName)?null==r||r.remove():console.warn(`[react-tooltip] Failed to remove 'style' element with id '${t}'. Call \`injectStyle()\` first`),w[e]=!1}const E=(e,t,r)=>{let o=null;return function(...n){const l=()=>{o=null,r||e.apply(this,n)};r&&!o&&(e.apply(this,n),o=setTimeout(l,t)),r||(o&&clearTimeout(o),o=setTimeout(l,t))}},_="DEFAULT_TOOLTIP_ID",g={anchorRefs:new Set,activeAnchor:{current:null},attach:()=>{},detach:()=>{},setActiveAnchor:()=>{}},A=t({getTooltipData:()=>g}),T=({children:t})=>{const[l,i]=r({[_]:new Set}),[c,s]=r({[_]:{current:null}}),a=(e,...t)=>{i((r=>{var o;const n=null!==(o=r[e])&&void 0!==o?o:new Set;return t.forEach((e=>n.add(e))),{...r,[e]:new Set(n)}}))},d=(e,...t)=>{i((r=>{const o=r[e];return o?(t.forEach((e=>o.delete(e))),{...r}):r}))},u=o(((e=_)=>{var t,r;return{anchorRefs:null!==(t=l[e])&&void 0!==t?t:new Set,activeAnchor:null!==(r=c[e])&&void 0!==r?r:{current:null},attach:(...t)=>a(e,...t),detach:(...t)=>d(e,...t),setActiveAnchor:t=>((e,t)=>{s((r=>{var o;return(null===(o=r[e])||void 0===o?void 0:o.current)===t.current?r:{...r,[e]:t}}))})(e,t)}}),[l,c,a,d]),p=n((()=>({getTooltipData:u})),[u]);return e.createElement(A.Provider,{value:p},t)};function L(e=_){return l(A).getTooltipData(e)}const O=({tooltipId:t,children:r,className:o,place:n,content:l,html:s,variant:a,offset:d,wrapper:u,events:p,positionStrategy:v,delayShow:m,delayHide:f})=>{const{attach:h,detach:w}=L(t),b=i(null);return c((()=>(h(b),()=>{w(b)})),[]),e.createElement("span",{ref:b,className:y("react-tooltip-wrapper",o),"data-tooltip-place":n,"data-tooltip-content":l,"data-tooltip-html":s,"data-tooltip-variant":a,"data-tooltip-offset":d,"data-tooltip-wrapper":u,"data-tooltip-events":p,"data-tooltip-position-strategy":v,"data-tooltip-delay-show":m,"data-tooltip-delay-hide":f},r)},R="undefined"!=typeof window?s:c,N=e=>{if(!(e instanceof HTMLElement||e instanceof SVGElement))return!1;const t=getComputedStyle(e);return["overflow","overflow-x","overflow-y"].some((e=>{const r=t.getPropertyValue(e);return"auto"===r||"scroll"===r}))},x=e=>{if(!e)return null;let t=e.parentElement;for(;t;){if(N(t))return t;t=t.parentElement}return document.scrollingElement||document.documentElement},k=async({elementReference:e=null,tooltipReference:t=null,tooltipArrowReference:r=null,place:o="top",offset:n=10,strategy:l="absolute",middlewares:i=[u(Number(n)),p(),v({padding:5})],border:c})=>{if(!e)return{tooltipStyles:{},tooltipArrowStyles:{},place:o};if(null===t)return{tooltipStyles:{},tooltipArrowStyles:{},place:o};const s=i;return r?(s.push(a({element:r,padding:5})),d(e,t,{placement:o,strategy:l,middleware:s}).then((({x:e,y:t,placement:r,middlewareData:o})=>{var n,l;const i={left:`${e}px`,top:`${t}px`,border:c},{x:s,y:a}=null!==(n=o.arrow)&&void 0!==n?n:{x:0,y:0},d=null!==(l={top:"bottom",right:"left",bottom:"top",left:"right"}[r.split("-")[0]])&&void 0!==l?l:"bottom",u=c&&{top:{borderBottom:c,borderRight:c},right:{borderBottom:c,borderLeft:c},bottom:{borderTop:c,borderLeft:c},left:{borderTop:c,borderRight:c}}[r.split("-")[0]];let p=0;if(c){const e=`${c}`.match(/(\d+)px/);p=(null==e?void 0:e[1])?Number(e[1]):1}return{tooltipStyles:i,tooltipArrowStyles:{left:null!=s?`${s}px`:"",top:null!=a?`${a}px`:"",right:"",bottom:"",...u,[d]:`-${4+p}px`},place:r}}))):d(e,t,{placement:"bottom",strategy:l,middleware:s}).then((({x:e,y:t,placement:r})=>({tooltipStyles:{left:`${e}px`,top:`${t}px`},tooltipArrowStyles:{},place:r})))};var $="core-styles-module_tooltip__3vRRp",C="core-styles-module_fixed__pcSol",I="core-styles-module_arrow__cvMwQ",B="core-styles-module_noArrow__xock6",j="core-styles-module_clickable__ZuTTB",D="core-styles-module_show__Nt9eE",H={tooltip:"styles-module_tooltip__mnnfp",arrow:"styles-module_arrow__K0L3T",dark:"styles-module_dark__xNqje",light:"styles-module_light__Z6W-X",success:"styles-module_success__A2AKt",warning:"styles-module_warning__SCK0X",error:"styles-module_error__JvumD",info:"styles-module_info__BWdHW"};const z=({id:t,className:n,classNameArrow:l,variant:s="dark",anchorId:a,anchorSelect:d,place:u="top",offset:p=10,events:v=["hover"],openOnClick:f=!1,positionStrategy:h="absolute",middlewares:w,wrapper:b,delayShow:S=0,delayHide:_=0,float:g=!1,hidden:A=!1,noArrow:T=!1,clickable:O=!1,closeOnEsc:N=!1,closeOnScroll:z=!1,closeOnResize:q=!1,style:W,position:M,afterShow:P,afterHide:F,content:K,contentWrapperRef:U,isOpen:X,setIsOpen:Y,activeAnchor:V,setActiveAnchor:Z,border:G,opacity:J})=>{const Q=i(null),ee=i(null),te=i(null),re=i(null),[oe,ne]=r(u),[le,ie]=r({}),[ce,se]=r({}),[ae,de]=r(!1),[ue,pe]=r(!1),ve=i(!1),me=i(null),{anchorRefs:ye,setActiveAnchor:fe}=L(t),he=i(!1),[we,be]=r([]),Se=i(!1),Ee=f||v.includes("click");R((()=>(Se.current=!0,()=>{Se.current=!1})),[]),c((()=>{if(!ae){const e=setTimeout((()=>{pe(!1)}),150);return()=>{clearTimeout(e)}}return()=>null}),[ae]);const _e=e=>{Se.current&&(e&&pe(!0),setTimeout((()=>{Se.current&&(null==Y||Y(e),void 0===X&&de(e))}),10))};c((()=>{if(void 0===X)return()=>null;X&&pe(!0);const e=setTimeout((()=>{de(X)}),10);return()=>{clearTimeout(e)}}),[X]),c((()=>{ae!==ve.current&&(ve.current=ae,ae?null==P||P():null==F||F())}),[ae]);const ge=(e=_)=>{re.current&&clearTimeout(re.current),re.current=setTimeout((()=>{he.current||_e(!1)}),e)},Ae=e=>{var t;if(!e)return;const r=null!==(t=e.currentTarget)&&void 0!==t?t:e.target;if(!(null==r?void 0:r.isConnected))return Z(null),void fe({current:null});S?(te.current&&clearTimeout(te.current),te.current=setTimeout((()=>{_e(!0)}),S)):_e(!0),Z(r),fe({current:r}),re.current&&clearTimeout(re.current)},Te=()=>{O?ge(_||100):_?ge():_e(!1),te.current&&clearTimeout(te.current)},Le=({x:e,y:t})=>{k({place:u,offset:p,elementReference:{getBoundingClientRect:()=>({x:e,y:t,width:0,height:0,top:t,left:e,right:e,bottom:t})},tooltipReference:Q.current,tooltipArrowReference:ee.current,strategy:h,middlewares:w,border:G}).then((e=>{Object.keys(e.tooltipStyles).length&&ie(e.tooltipStyles),Object.keys(e.tooltipArrowStyles).length&&se(e.tooltipArrowStyles),ne(e.place)}))},Oe=e=>{if(!e)return;const t=e,r={x:t.clientX,y:t.clientY};Le(r),me.current=r},Re=e=>{Ae(e),_&&ge()},Ne=e=>{var t;[document.querySelector(`[id='${a}']`),...we].some((t=>null==t?void 0:t.contains(e.target)))||(null===(t=Q.current)||void 0===t?void 0:t.contains(e.target))||(_e(!1),te.current&&clearTimeout(te.current))},xe=E(Ae,50,!0),ke=E(Te,50,!0),$e=o((()=>{M?Le(M):g?me.current&&Le(me.current):k({place:u,offset:p,elementReference:V,tooltipReference:Q.current,tooltipArrowReference:ee.current,strategy:h,middlewares:w,border:G}).then((e=>{Se.current&&(Object.keys(e.tooltipStyles).length&&ie(e.tooltipStyles),Object.keys(e.tooltipArrowStyles).length&&se(e.tooltipArrowStyles),ne(e.place))}))}),[ae,V,K,W,u,p,h,M,g]);c((()=>{var e,t;const r=new Set(ye);we.forEach((e=>{r.add({current:e})}));const o=document.querySelector(`[id='${a}']`);o&&r.add({current:o});const n=()=>{_e(!1)},l=x(V),i=x(Q.current);z&&(window.addEventListener("scroll",n),null==l||l.addEventListener("scroll",n),null==i||i.addEventListener("scroll",n));let c=null;q?window.addEventListener("resize",n):V&&Q.current&&(c=m(V,Q.current,$e,{ancestorResize:!0,elementResize:!0,layoutShift:!0}));const s=e=>{"Escape"===e.key&&_e(!1)};N&&window.addEventListener("keydown",s);const d=[];Ee?(window.addEventListener("click",Ne),d.push({event:"click",listener:Re})):(d.push({event:"mouseenter",listener:xe},{event:"mouseleave",listener:ke},{event:"focus",listener:xe},{event:"blur",listener:ke}),g&&d.push({event:"mousemove",listener:Oe}));const u=()=>{he.current=!0},p=()=>{he.current=!1,Te()};return O&&!Ee&&(null===(e=Q.current)||void 0===e||e.addEventListener("mouseenter",u),null===(t=Q.current)||void 0===t||t.addEventListener("mouseleave",p)),d.forEach((({event:e,listener:t})=>{r.forEach((r=>{var o;null===(o=r.current)||void 0===o||o.addEventListener(e,t)}))})),()=>{var e,t;z&&(window.removeEventListener("scroll",n),null==l||l.removeEventListener("scroll",n),null==i||i.removeEventListener("scroll",n)),q?window.removeEventListener("resize",n):null==c||c(),Ee&&window.removeEventListener("click",Ne),N&&window.removeEventListener("keydown",s),O&&!Ee&&(null===(e=Q.current)||void 0===e||e.removeEventListener("mouseenter",u),null===(t=Q.current)||void 0===t||t.removeEventListener("mouseleave",p)),d.forEach((({event:e,listener:t})=>{r.forEach((r=>{var o;null===(o=r.current)||void 0===o||o.removeEventListener(e,t)}))}))}}),[V,$e,ue,ye,we,N,v]),c((()=>{let e=null!=d?d:"";!e&&t&&(e=`[data-tooltip-id='${t}']`);const r=new MutationObserver((r=>{const o=[];r.forEach((r=>{if("attributes"===r.type&&"data-tooltip-id"===r.attributeName){r.target.getAttribute("data-tooltip-id")===t&&o.push(r.target)}if("childList"===r.type&&(V&&[...r.removedNodes].some((e=>{var t;return!!(null===(t=null==e?void 0:e.contains)||void 0===t?void 0:t.call(e,V))&&(pe(!1),_e(!1),Z(null),te.current&&clearTimeout(te.current),re.current&&clearTimeout(re.current),!0)})),e))try{const t=[...r.addedNodes].filter((e=>1===e.nodeType));o.push(...t.filter((t=>t.matches(e)))),o.push(...t.flatMap((t=>[...t.querySelectorAll(e)])))}catch(e){}})),o.length&&be((e=>[...e,...o]))}));return r.observe(document.body,{childList:!0,subtree:!0,attributes:!0,attributeFilter:["data-tooltip-id"]}),()=>{r.disconnect()}}),[t,d,V]),c((()=>{$e()}),[$e]),c((()=>{if(!(null==U?void 0:U.current))return()=>null;const e=new ResizeObserver((()=>{$e()}));return e.observe(U.current),()=>{e.disconnect()}}),[K,null==U?void 0:U.current]),c((()=>{var e;const t=document.querySelector(`[id='${a}']`),r=[...we,t];V&&r.includes(V)||Z(null!==(e=we[0])&&void 0!==e?e:t)}),[a,we,V]),c((()=>()=>{te.current&&clearTimeout(te.current),re.current&&clearTimeout(re.current)}),[]),c((()=>{let e=d;if(!e&&t&&(e=`[data-tooltip-id='${t}']`),e)try{const t=Array.from(document.querySelectorAll(e));be(t)}catch(e){be([])}}),[t,d]);const Ce=!A&&K&&ae&&Object.keys(le).length>0;return ue?e.createElement(b,{id:t,role:"tooltip",className:y("react-tooltip",$,H.tooltip,H[s],n,`react-tooltip__place-${oe}`,{"react-tooltip__show":Ce,[D]:Ce,[C]:"fixed"===h,[j]:O}),style:{...W,...le,opacity:void 0!==J&&Ce?J:void 0},ref:Q},K,e.createElement(b,{className:y("react-tooltip-arrow",I,H.arrow,l,{[B]:T}),style:ce,ref:ee})):null},q=({content:t})=>e.createElement("span",{dangerouslySetInnerHTML:{__html:t}}),W=({id:t,anchorId:o,anchorSelect:n,content:l,html:s,render:a,className:d,classNameArrow:u,variant:p="dark",place:v="top",offset:m=10,wrapper:y="div",children:f=null,events:h=["hover"],openOnClick:w=!1,positionStrategy:b="absolute",middlewares:S,delayShow:E=0,delayHide:_=0,float:g=!1,hidden:A=!1,noArrow:T=!1,clickable:O=!1,closeOnEsc:R=!1,closeOnScroll:N=!1,closeOnResize:x=!1,style:k,position:$,isOpen:C,disableStyleInjection:I=!1,border:B,opacity:j,setIsOpen:D,afterShow:H,afterHide:W})=>{const[M,P]=r(l),[F,K]=r(s),[U,X]=r(v),[Y,V]=r(p),[Z,G]=r(m),[J,Q]=r(E),[ee,te]=r(_),[re,oe]=r(g),[ne,le]=r(A),[ie,ce]=r(y),[se,ae]=r(h),[de,ue]=r(b),[pe,ve]=r(null),me=i(I),{anchorRefs:ye,activeAnchor:fe}=L(t),he=e=>null==e?void 0:e.getAttributeNames().reduce(((t,r)=>{var o;if(r.startsWith("data-tooltip-")){t[r.replace(/^data-tooltip-/,"")]=null!==(o=null==e?void 0:e.getAttribute(r))&&void 0!==o?o:null}return t}),{}),we=e=>{const t={place:e=>{var t;X(null!==(t=e)&&void 0!==t?t:v)},content:e=>{P(null!=e?e:l)},html:e=>{K(null!=e?e:s)},variant:e=>{var t;V(null!==(t=e)&&void 0!==t?t:p)},offset:e=>{G(null===e?m:Number(e))},wrapper:e=>{var t;ce(null!==(t=e)&&void 0!==t?t:y)},events:e=>{const t=null==e?void 0:e.split(" ");ae(null!=t?t:h)},"position-strategy":e=>{var t;ue(null!==(t=e)&&void 0!==t?t:b)},"delay-show":e=>{Q(null===e?E:Number(e))},"delay-hide":e=>{te(null===e?_:Number(e))},float:e=>{oe(null===e?g:"true"===e)},hidden:e=>{le(null===e?A:"true"===e)}};Object.values(t).forEach((e=>e(null))),Object.entries(e).forEach((([e,r])=>{var o;null===(o=t[e])||void 0===o||o.call(t,r)}))};c((()=>{P(l)}),[l]),c((()=>{K(s)}),[s]),c((()=>{X(v)}),[v]),c((()=>{V(p)}),[p]),c((()=>{G(m)}),[m]),c((()=>{Q(E)}),[E]),c((()=>{te(_)}),[_]),c((()=>{oe(g)}),[g]),c((()=>{le(A)}),[A]),c((()=>{ue(b)}),[b]),c((()=>{me.current!==I&&console.warn("[react-tooltip] Do not change `disableStyleInjection` dynamically.")}),[I]),c((()=>{"undefined"!=typeof window&&window.dispatchEvent(new CustomEvent("react-tooltip-inject-styles",{detail:{disableCore:"core"===I,disableBase:I}}))}),[]),c((()=>{var e;const r=new Set(ye);let l=n;if(!l&&t&&(l=`[data-tooltip-id='${t}']`),l)try{document.querySelectorAll(l).forEach((e=>{r.add({current:e})}))}catch(e){console.warn(`[react-tooltip] "${l}" is not a valid CSS selector`)}const i=document.querySelector(`[id='${o}']`);if(i&&r.add({current:i}),!r.size)return()=>null;const c=null!==(e=null!=pe?pe:i)&&void 0!==e?e:fe.current,s=new MutationObserver((e=>{e.forEach((e=>{var t;if(!c||"attributes"!==e.type||!(null===(t=e.attributeName)||void 0===t?void 0:t.startsWith("data-tooltip-")))return;const r=he(c);we(r)}))})),a={attributes:!0,childList:!1,subtree:!1};if(c){const e=he(c);we(e),s.observe(c,a)}return()=>{s.disconnect()}}),[ye,fe,pe,o,n]),c((()=>{(null==k?void 0:k.border)&&console.warn("[react-tooltip] Do not set `style.border`. Use `border` prop instead."),B&&!CSS.supports("border",`${B}`)&&console.warn(`[react-tooltip] "${B}" is not a valid \`border\`.`),(null==k?void 0:k.opacity)&&console.warn("[react-tooltip] Do not set `style.opacity`. Use `opacity` prop instead."),j&&!CSS.supports("opacity",`${j}`)&&console.warn(`[react-tooltip] "${j}" is not a valid \`opacity\`.`)}),[]);let be=f;const Se=i(null);if(a){const t=a({content:null!=M?M:null,activeAnchor:pe});be=t?e.createElement("div",{ref:Se,className:"react-tooltip-content-wrapper"},t):null}else M&&(be=M);F&&(be=e.createElement(q,{content:F}));const Ee={id:t,anchorId:o,anchorSelect:n,className:d,classNameArrow:u,content:be,contentWrapperRef:Se,place:U,variant:Y,offset:Z,wrapper:ie,events:se,openOnClick:w,positionStrategy:de,middlewares:S,delayShow:J,delayHide:ee,float:re,hidden:ne,noArrow:T,clickable:O,closeOnEsc:R,closeOnScroll:N,closeOnResize:x,style:k,position:$,isOpen:C,border:B,opacity:j,setIsOpen:D,afterShow:H,afterHide:W,activeAnchor:pe,setActiveAnchor:e=>ve(e)};return e.createElement(z,{...Ee})};"undefined"!=typeof window&&window.addEventListener("react-tooltip-inject-styles",(e=>{e.detail.disableCore||b({css:`:root{--rt-color-white:#fff;--rt-color-dark:#222;--rt-color-success:#8dc572;--rt-color-error:#be6464;--rt-color-warning:#f0ad4e;--rt-color-info:#337ab7;--rt-opacity:0.9}.core-styles-module_tooltip__3vRRp{visibility:hidden;position:absolute;top:0;left:0;pointer-events:none;opacity:0;transition:opacity 0.3s ease-out;will-change:opacity,visibility}.core-styles-module_fixed__pcSol{position:fixed}.core-styles-module_arrow__cvMwQ{position:absolute;background:inherit}.core-styles-module_noArrow__xock6{display:none}.core-styles-module_clickable__ZuTTB{pointer-events:auto}.core-styles-module_show__Nt9eE{visibility:visible;opacity:var(--rt-opacity)}`,type:"core"}),e.detail.disableBase||b({css:`
.styles-module_tooltip__mnnfp{padding:8px 16px;border-radius:3px;font-size:90%;width:max-content}.styles-module_arrow__K0L3T{width:8px;height:8px;transform:rotate(45deg)}.styles-module_dark__xNqje{background:var(--rt-color-dark);color:var(--rt-color-white)}.styles-module_light__Z6W-X{background-color:var(--rt-color-white);color:var(--rt-color-dark)}.styles-module_success__A2AKt{background-color:var(--rt-color-success);color:var(--rt-color-white)}.styles-module_warning__SCK0X{background-color:var(--rt-color-warning);color:var(--rt-color-white)}.styles-module_error__JvumD{background-color:var(--rt-color-error);color:var(--rt-color-white)}.styles-module_info__BWdHW{background-color:var(--rt-color-info);color:var(--rt-color-white)}`,type:"base"})}));export{W as Tooltip,T as TooltipProvider,O as TooltipWrapper,S as removeStyle};
